
#include "kernel.h"

__declspec(naked) void __multiboot_entry__(void)
{
	__asm {
        multiboot_header:
		    dd(MAGIC)          ; magic
			dd(FLAGS)          ; flags
			dd(CHECKSUM)       ; checksum
			dd(HEADER_ADR)     ; header_addr
			dd(LOAD_ADR)       ; load_addr
			dd(LOAD_END_ADR)   ; load_end_addr
			dd(BSS_END_ADR)    ; bss_end_addr
			dd(ENTRY_ADR)      ; entry_addr
			dd(MODE_TYPE)      ; mode_type
			dd(WIDTH)          ; width
			dd(HEIGHT)         ; height
			dd(DEPTH)          ; depth

        kernel_entry:
			mov     esp, KERNEL_STACK
			
			xor     ecx, ecx
			push    ecx
			popf
			
			push    eax
			push    ebx
			call    main

			jmp     $
      }
}


void main(ULONG magic, ULONG addr)
{
    gdt_install();
    idt_install();
	init_video();
//    isrs_install();
    irq_install();
    timer_install();
    keyboard_install();

	__asm sti;

	for(;;);
}
